package com.ims.eval.controller;


import com.baomidou.mybatisplus.core.metadata.IPage;
import com.ims.eval.dao.result.R;
import com.ims.eval.entity.DataDictionary;
import com.ims.eval.entity.EvaluateRule;
import com.ims.eval.entity.Indicator;
import com.ims.eval.service.IEvaluateRuleService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;

/**
 * <p>
 * 考评规则表 前端控制器
 * </p>
 *
 * @author wang
 * @since 2023-02-27
 */
@RestController
@RequestMapping("//evaluate-rule")
public class EvaluateRuleController {


	@Autowired
	private IEvaluateRuleService evaluateRuleService;

	/**
	 * 查询 list
	 *
	 * @param id             主键
	 * @param des            描述
	 * @param indicatorId    指标ID
	 * @param evaluateMethod 评分方式
	 * @return
	 */
	//@ImsPreAuth("eval:dataDictionary:view")
	@GetMapping(value = "list")
	public R list(@RequestParam(value = "pageNum") Integer pageNum,
				  @RequestParam(value = "pageSize") Integer pageSize,
				  @RequestParam(value = "id", required = false) String id,
				  @RequestParam(value = "des", required = false) String des,
				  @RequestParam(value = "indicatorId", required = false) String indicatorId,
				  @RequestParam(value = "evaluateMethod", required = false) String evaluateMethod) {
		IPage<EvaluateRule> list = evaluateRuleService.list(pageNum, pageSize, id, des, indicatorId, evaluateMethod);
		return R.ok().data(list);
	}


	/**
	 * 添加
	 *
	 * @param evaluateRule
	 * @return
	 */

	//@ImsPreAuth("eval:dataDictionary:edit")
	@PostMapping(value = "/save")
	@ApiOperation(value = "新增(修改)", notes = "新增（修改）")
	public R addAll(@RequestBody EvaluateRule evaluateRule) {

		boolean b = evaluateRuleService.saveOrUpdate(evaluateRule);
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error().data("保存失败！");
		}
	}


	/**
	 * 批量删除
	 *
	 * @param ids
	 * @return
	 */
	//@ImsPreAuth("eval:dataDictionary:remove")
	@DeleteMapping(value = "/remove/{ids}")
	@ApiOperation(value = "删除", notes = "删除")
	public R deleteAll(@PathVariable("ids") String ids) {
		String[] strings = ids.split(",");
		boolean b = evaluateRuleService.removeByIds(Arrays.asList(strings));
		if (b) {
			return R.ok().data(b);
		} else {
			return R.error().data("删除失败！");
		}
	}
}
